package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.CategoriaFormAutorizacaoDAO;
import com.rjconsultores.ventaboletos.entidad.CategoriaDescuento;
import com.rjconsultores.ventaboletos.entidad.CategoriaFormAutorizacao;

@Repository("CategoriaDescuentoDAO")
public class CategoriaFormAutorizacaoHibernateDAO extends GenericHibernateDAO<CategoriaFormAutorizacao, Integer>
implements CategoriaFormAutorizacaoDAO {

	@Autowired
    public CategoriaFormAutorizacaoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<CategoriaFormAutorizacao> obtenerTodosPorCategoria(Integer categoriaId) {
    	Criteria c = getSession().createCriteria(getPersistentClass())
    	        .add(Restrictions.eq("activo", Boolean.TRUE))
    	        .add(Restrictions.eq("categoria.categoriaId", categoriaId));

        return c.list();
    }
    
    @Override
    public CategoriaFormAutorizacao pesquisarPorCategoriaEmpresa(Integer categoriaId, Integer empresaId){
    	Criteria c = getSession().createCriteria(getPersistentClass())
        .add(Restrictions.eq("activo", Boolean.TRUE))
        .add(Restrictions.eq("empresaId", empresaId))
        .add(Restrictions.eq("categoriaId", categoriaId));
    	c.setMaxResults(1);

    	return (CategoriaFormAutorizacao) c.uniqueResult();
    }
    
    @Override
    public CategoriaFormAutorizacao saverOrUpdate(CategoriaFormAutorizacao form) {
    	getHibernateTemplate().saveOrUpdate(form);
    	return form;
    }

}
